#include <stdio.h>
#include <stdlib.h>
#include "grafo.h"

/*
 * Realizar una función compruebe si el grafo pasado como parámetro tiene un
 * camino euleriano.
 */
int tieneCaminoEuleriano(Grafo *g)
{
}

int main(int argc, char *argv[])
{
  Grafo *g;
  int *grados, i;

  printf("-----------------------------------------------------------------\n");
  g = crearGrafoRegular(10);
  imprimirGrafo(g);
  imprimirEnAnchura(g, 0);
  imprimirEnProfundidad(g, 0);
  grados = contarGradosVertices(g);
  for(i = 0; i < g->n_vertices; i++) {
    printf("V%2d. Salidas: %2d, Entradas: %2d\n", i, grados[2*i], grados[2*i+1]);
  }
  free(grados);
  borrarGrafo(g); 
 
  printf("-----------------------------------------------------------------\n");
  g = crearGrafoAleatorio(10, 10, 1, 10);
  imprimirGrafo(g);
  imprimirEnAnchura(g, 0);
  imprimirEnProfundidad(g, 0);
  grados = contarGradosVertices(g);
  for(i = 0; i < g->n_vertices; i++) {
    printf("V%2d. Salidas: %2d, Entradas: %2d\n", i, grados[2*i], grados[2*i+1]);
  }
  free(grados);
  borrarGrafo(g); 

  /* Grafo de la casa
         0
        / \
       1---2
       |  /|
       | / |
       |/  |
       3---4
   */
  g = crearGrafo(5);
  aniadirArista(g,0,1,1); 
  aniadirArista(g,0,2,1);  
  aniadirArista(g,1,2,1);
  aniadirArista(g,1,3,1);
  aniadirArista(g,2,3,1);
  aniadirArista(g,2,4,1);
  aniadirArista(g,3,4,1);
  printf("Tiene camino eulerino: %s\n", tieneCaminoEuleriano(g)>0 ? "SI" : "NO");
  borrarGrafo(g); 

  /* Grafo de los puentes de Königsberg 
   * 
   * Ver: https://es.wikipedia.org/wiki/Problema_de_los_puentes_de_K%C3%B6nigsberg
   **/
  g = crearGrafo(4);
  aniadirArista(g,0,2,1); 
  aniadirArista(g,0,1,1); 
  aniadirArista(g,0,1,1); 
  aniadirArista(g,1,2,1); 
  aniadirArista(g,1,3,1); 
  aniadirArista(g,1,3,1); 
  aniadirArista(g,2,3,1); 
  printf("Tiene camino eulerino: %s\n", tieneCaminoEuleriano(g)>0 ? "SI" : "NO");
  borrarGrafo(g); 

  return 0;
}


